/* funkce na vypocet hodnoty libovolneho polynomu s koeficienty v poli
   funkce na vypocet hodnoty derivace libovolneho polynomu s koeficienty v poli
   vypocet hornerovym schematem
*/

#include <stdio.h>

/* vypocet hodnoty obecneho polynomu */
double poly(double x, double koef[], int rad)
{
 int i;
 double y;

 y=0;
 for (i=rad;i>=0;i--)
  {
   y=y*x+koef[i];
  }
 return y;
}

/* vypocet hodnoty 1. derivace obecneho polynomu */
double dpoly(double x, double koef[], int rad)
{
 int i;
 double pom[20];

 if ((rad<1)||(rad>20)) return 0;

 for (i=1;i<=rad;i++) pom[i-1]=i*koef[i];
 return poly(x, pom, rad-1);
}

int main()
{
 /* vypise tabulku fukce v intervalu -1..1 s krokem 0.1 */
 int i;
 double P[4]={1.0,-2.0,0.0,1.0};

 for (i=-10;i<=10;i++)
     printf("%4.1f %8.3f %8.3f\n", 0.1*i, poly(0.1*i, P, 3), dpoly(0.1*i, P, 3));

 getchar();
 return 0;
}
