/* priklady na funkce s polem jako parametr */

#include <stdio.h>

double soucet(double X[], int vel)	// funkce vraci soucet prvku libovolne velkeho pole typu double
{
 double souc=0;
 int i;
 for (i=0;i<vel;i++)
   souc+=X[i];
 return souc;
}

int pocnul(double X[], int vel)	// funkce vraci pocet nulovych prvku libovolne velkeho pole typu double
{
 int poc=0;
 int i;
 for (i=0;i<vel;i++)
   if (X[i]==0.0) poc++;
 return poc;
}

void nacti_pole(double X[], int vel) // funkce nacte z klavesnice prvky libovolne velkeho pole typu double
{									 // nezadane prvky budou nulove
 int i, ok;
 char s[130];
 for (i=0;i<vel;i++) X[i]=0;
 for (i=0;i<vel;i++)
  {
   do {
    printf("\nZadej %d. cislo: ", i+1);
    gets(s);
    if (s[0]==0) return;
    ok=sscanf(s, "%lf", &X[i]);
    } while(ok==0);

  }
}

void vypis_pole(double X[], int vel)	// funkce vypise obsah pole
{
 int i;
 putchar('\n');
 for (i=0;i<vel;i++)
  {
   printf("%8.3f", X[i]);
  }

}

int porovnej_pole(double A[], double B[], int vel)	// funkce porovna dve pole na shodu hodnot
{
 int i;
 for (i=0;i<vel;i++)
  {
   if (A[i]!=B[i]) return 0;
  }
 return 1;
}

int main()
{
 double P[10], Q[10];

 printf("\nZadej prvni pole:");
 nacti_pole(P, 10);
 printf("\nZadej druhe pole:");
 nacti_pole(Q, 10);
 printf("\nPrvni pole:");
 vypis_pole(P, 10);
 printf("\nDruhe pole:");
 vypis_pole(Q, 10);
 printf("\nSoucty celeho pole");
 printf("\nSoucet1=%.3f Soucet2=%.3f", soucet(P,10), soucet(Q,10));
 printf("\nSoucty prvnich 4 prvku pole");
 printf("\nSoucet1=%.3f Soucet2=%.3f", soucet(P,4), soucet(Q,4));
 printf("\nPole1 obsahuje %d nul, Pole2 obsahuje %d nul",
	pocnul(P,10), pocnul(Q,10));

 printf("\nPole %sjsou shodna.", porovnej_pole(P, Q, 10)?"":"ne");

 getchar();
 return 0;
}
